------------------------------------------------------------
-- Chakra.lua
--
-- Abin
-- 2011/11/13
------------------------------------------------------------

if select(2, UnitClass("player")) ~= "PRIEST" then return end

local _, addon = ...
local L = addon.L

local spellList = {}
addon:BuildSpellList(spellList, 81208)
addon:BuildSpellList(spellList, 81206)
addon:BuildSpellList(spellList, 81209)

spellList[1].id = 14751
spellList[2].id = 14751
spellList[3].id = 14751

local chakra = GetSpellInfo(14751)
local rightSpells = {}
rightSpells[1] = GetSpellInfo(2061)
rightSpells[2] = GetSpellInfo(596)
rightSpells[3] = GetSpellInfo(73510)

local button = addon:CreateActionButton("PriestChakra", chakra, nil, nil, "DUAL", "PLAYER_AURA")
button:SetFlyProtect()
button:SetScrollable(spellList, "spell2", [[
	if index == 3 then
		self:SetAttribute("unit", nil)
	else
		self:SetAttribute("unit", "player")
	end
]])

button:RequireSpell(14751)
button:SetAttribute("spell1", chakra)
button:SetAttribute("spellList1", rightSpells[1])
button:SetAttribute("spellList2", rightSpells[2])
button:SetAttribute("spellList3", rightSpells[3])

function button:OnIndexChanged(index)
	self.spell2 = rightSpells[index]
end

function button:OnTalentSwitch()
	local index = self.index
	self:SetAttribute("spell2", self.spell2)
	self:SetAttribute("unit", index ~= 3 and "player" or nil)
end

function button:OnTooltipLeftText(tooltip, spell)
	tooltip:AddLine(L["left click"]..chakra, 1, 1, 1, 1)
end

function button:OnUpdateTimer(spell)
	if addon:GetUnitBuffTimer("player", spell) then
		return 1
	end

	if addon:GetUnitBuffTimer("player", chakra) then
		return -1
	end
end
